// This program performs the thread creation test several times for an increasing number of threads

public class ThreadCreationSeries {
  
  public static void main(String[] args)
  {

    int[] steps = {100, 500, 1000, 1500, 2000, 5000, 10000, 50000, 100000, 500000, 1000000};
    
    for(int i = 0; i < steps.length; i++)
    {
      long[] result = new long[3];
      result[0] = LaunchThreads(steps[i]);
      result[1] = LaunchThreads(steps[i]);
      result[2] = LaunchThreads(steps[i]);
      
      long actualResult = (result[0]+result[1]+result[2])/3;
      
      System.out.println(steps[i]+ "\t threads: " + actualResult + " ms  \t\t(" + result[0]
                         + " " + result[1] + " " +result[2] +")");
    }

  }

  public static long LaunchThreads(int number)
  {
    long start = System.currentTimeMillis();

    for(int i = 0; i < number; i++)
    {
      DummyThread dt = new DummyThread();
      dt.start();
    }
    long end = System.currentTimeMillis();
    
    return(end - start);
  }
}
