#include <boost/thread.hpp>
#include <stdlib.h>
#include <stdio.h>
#include <ctime>

/*
 *	This program creates a given number of boost threads and measures the time
 */


void threadFunction()
{
  int i;

  for(i = 0; i < 1000; i++)
  {

  }
}

int main(int argc, char* argv[])
{
  clock_t start, end;

  int threadNumber = atoi(argv[1]);

  printf("Now launching %d threads\n", threadNumber);

  // Start the timer
  start = clock();
  for(int i = 0; i < threadNumber; i++)
  {
    boost::thread myThread(threadFunction);
  }
  // Stop the timer
  end = clock(); 
  printf("Created %d threads. Time used: %4.2f ms\n",threadNumber, 
            ((double)(end - start)/CLOCKS_PER_SEC)*1000);
}
