#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <ctime>

/*
 *	This program creates a given number of pthreads and measures the time
 */

void *dummy_method(void *ptr)
{
  int i = 0;

  for(i = 0; i < 1000; i++)
  {
    
  }
}

main(int argc, char* argv[])
{
  clock_t start, end;

  if( argc < 2)
  {
    printf("Please specify the number of threads you wish to launch!\n");
    return 1;
  }

  int threadNumber = atoi(argv[1]);
  printf("Now launching  %s threads!\n" ,argv[1]);

  int i;
  pthread_t pt;
  char* message = "xxx";

  // start the timer
  start = clock();
  for(i = 0; i < threadNumber; i++)
  {
   
    int ret;

    ret = pthread_create( &pt, NULL, dummy_method, (void*) message);
    // printf("created thread %d ---- return value: %d\n", i, ret);
  }
  // stop the timer
  end = clock();
  printf("Created %d threads. Time used: %4.2f ms\n",threadNumber, ((double)(end - start)/CLOCKS_PER_SEC)*1000);
  pthread_join(pt, NULL);
}
